// WARNING: This file was automatically generated. Do not edit it directly,
//          or you will lose your changes.
/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
package org.apache.myfaces.commons.converter;

import javax.faces.context.FacesContext;
import javax.el.ELContext;
import javax.faces.convert.Converter;
import javax.el.ValueExpression;
import javax.faces.webapp.UIComponentTag;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import java.util.TimeZone;
import java.util.Locale;


public class ConvertDateTimeTag
    extends org.apache.myfaces.commons.converter.ConverterTag
{
    private static final long serialVersionUID = 1542071733367150635L; 

    public ConvertDateTimeTag()
    {
        setConverterIdString("org.apache.myfaces.custom.convertDateTime.DateTimeConverter");
    }
 
    private ValueExpression _dateStyle;
    
    public void setDateStyle(ValueExpression dateStyle)
    {
        _dateStyle = dateStyle;
    }
 
    private ValueExpression _locale;
    
    public void setLocale(ValueExpression locale)
    {
        _locale = locale;
    }
 
    private ValueExpression _pattern;
    
    public void setPattern(ValueExpression pattern)
    {
        _pattern = pattern;
    }
 
    private ValueExpression _timeStyle;
    
    public void setTimeStyle(ValueExpression timeStyle)
    {
        _timeStyle = timeStyle;
    }
 
    private ValueExpression _timeZone;
    
    public void setTimeZone(ValueExpression timeZone)
    {
        _timeZone = timeZone;
    }
 
    private ValueExpression _type;
    
    public void setType(ValueExpression type)
    {
        _type = type;
    }

    public void setPageContext(PageContext context) {
        super.setPageContext(context);
        setConverterIdString("org.apache.myfaces.custom.convertDateTime.DateTimeConverter");
    }

    protected Converter createConverter() throws JspException {
    
        ELContext elContext = FacesContext.getCurrentInstance().getELContext();            
        org.apache.myfaces.commons.converter.DateTimeConverter converter = (org.apache.myfaces.commons.converter.DateTimeConverter)super.createConverter();
        if (_dateStyle != null)
        {
            if (_dateStyle.isLiteralText())
            {
                converter.setDateStyle(_dateStyle.getExpressionString());
            }
            else
            {
                converter.setDateStyle( (String) _dateStyle.getValue(elContext));
            }
        }
        if (_locale != null)
        {
            if (_locale.isLiteralText())
            {
                converter.setLocale(
                    org.apache.myfaces.commons.util.TagUtils.getLocale(_locale.getExpressionString()));
            }
            else
            {
                Object _localeValue = _locale.getValue(elContext);                
                if (_localeValue == null)
                {
                    _localeValue = FacesContext.getCurrentInstance().getViewRoot().getLocale();                
                }
                else
                {
                    _localeValue = org.apache.myfaces.commons.util.TagUtils.getLocale(_localeValue);                
                }
                converter.setLocale((java.util.Locale)_localeValue);
            }
        }
        if (_pattern != null)
        {
            if (_pattern.isLiteralText())
            {
                converter.setPattern(_pattern.getExpressionString());
            }
            else
            {
                converter.setPattern( (String) _pattern.getValue(elContext));
            }
        }
        if (_timeStyle != null)
        {
            if (_timeStyle.isLiteralText())
            {
                converter.setTimeStyle(_timeStyle.getExpressionString());
            }
            else
            {
                converter.setTimeStyle( (String) _timeStyle.getValue(elContext));
            }
        }
        if (_timeZone != null)
        {
            if (_timeZone.isLiteralText())
            {
                converter.setTimeZone(
                    java.util.TimeZone.getTimeZone(_timeZone.getExpressionString()));                
            }
            else
            {
                Object _timeZoneValue = _timeZone.getValue(elContext);
                if(_timeZoneValue instanceof java.util.TimeZone)
                {
                    converter.setTimeZone(
                        (java.util.TimeZone) _timeZoneValue);
                }
                else
                {
                    converter.setTimeZone(
                        java.util.TimeZone.getTimeZone(_timeZoneValue.toString()));
                }
            }
        }
        if (_type != null)
        {
            if (_type.isLiteralText())
            {
                converter.setType(_type.getExpressionString());
            }
            else
            {
                converter.setType( (String) _type.getValue(elContext));
            }
        }
        return converter;
    }

    public void release()
    {
        super.release();
        _dateStyle = null;
        _locale = null;
        _pattern = null;
        _timeStyle = null;
        _timeZone = null;
        _type = null;
    }
}
