// WARNING: This file was automatically generated. Do not edit it directly,
//          or you will lose your changes.
/*
 *  Licensed to the Apache Software Foundation (ASF) under one
 *  or more contributor license agreements.  See the NOTICE file
 *  distributed with this work for additional information
 *  regarding copyright ownership.  The ASF licenses this file
 *  to you under the Apache License, Version 2.0 (the
 *  "License"); you may not use this file except in compliance
 *  with the License.  You may obtain a copy of the License at
 * 
 *  http://www.apache.org/licenses/LICENSE-2.0
 * 
 *  Unless required by applicable law or agreed to in writing,
 *  software distributed under the License is distributed on an
 *  "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 *  KIND, either express or implied.  See the License for the
 *  specific language governing permissions and limitations
 *  under the License.
 */
package org.apache.myfaces.commons.converter;

import javax.faces.context.FacesContext;
import javax.el.ELContext;
import javax.faces.convert.Converter;
import javax.el.ValueExpression;
import javax.faces.webapp.UIComponentTag;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.PageContext;
import java.util.Locale;


public class TypedNumberConverterTag
    extends org.apache.myfaces.commons.converter.ConverterTag
{
    private static final long serialVersionUID = -6592309048440572608L; 

    public TypedNumberConverterTag()
    {
        setConverterIdString("org.apache.myfaces.custom.convertNumber.TypedNumberConverter");
    }
 
    private ValueExpression _destType;
    
    public void setDestType(ValueExpression destType)
    {
        _destType = destType;
    }
 
    private ValueExpression _currencyCode;
    
    public void setCurrencyCode(ValueExpression currencyCode)
    {
        _currencyCode = currencyCode;
    }
 
    private ValueExpression _currencySymbol;
    
    public void setCurrencySymbol(ValueExpression currencySymbol)
    {
        _currencySymbol = currencySymbol;
    }
 
    private ValueExpression _groupingUsed;
    
    public void setGroupingUsed(ValueExpression groupingUsed)
    {
        _groupingUsed = groupingUsed;
    }
 
    private ValueExpression _integerOnly;
    
    public void setIntegerOnly(ValueExpression integerOnly)
    {
        _integerOnly = integerOnly;
    }
 
    private ValueExpression _locale;
    
    public void setLocale(ValueExpression locale)
    {
        _locale = locale;
    }
 
    private ValueExpression _maxFractionDigits;
    
    public void setMaxFractionDigits(ValueExpression maxFractionDigits)
    {
        _maxFractionDigits = maxFractionDigits;
    }
 
    private ValueExpression _maxIntegerDigits;
    
    public void setMaxIntegerDigits(ValueExpression maxIntegerDigits)
    {
        _maxIntegerDigits = maxIntegerDigits;
    }
 
    private ValueExpression _minFractionDigits;
    
    public void setMinFractionDigits(ValueExpression minFractionDigits)
    {
        _minFractionDigits = minFractionDigits;
    }
 
    private ValueExpression _minIntegerDigits;
    
    public void setMinIntegerDigits(ValueExpression minIntegerDigits)
    {
        _minIntegerDigits = minIntegerDigits;
    }
 
    private ValueExpression _pattern;
    
    public void setPattern(ValueExpression pattern)
    {
        _pattern = pattern;
    }
 
    private ValueExpression _type;
    
    public void setType(ValueExpression type)
    {
        _type = type;
    }

    public void setPageContext(PageContext context) {
        super.setPageContext(context);
        setConverterIdString("org.apache.myfaces.custom.convertNumber.TypedNumberConverter");
    }

    protected Converter createConverter() throws JspException {
    
        ELContext elContext = FacesContext.getCurrentInstance().getELContext();            
        org.apache.myfaces.commons.converter.TypedNumberConverter converter = (org.apache.myfaces.commons.converter.TypedNumberConverter)super.createConverter();
        if (_destType != null)
        {
            if (_destType.isLiteralText())
            {
                try
                {
                    converter.setDestType(
                    org.apache.myfaces.commons.util.ClassUtils.classForName(_destType.getExpressionString()));
                }
                catch (ClassNotFoundException e)
                {
                    throw new JspException(e);
                }
            }
            else
            {
                converter.setDestType((java.lang.Class) _destType.getValue(elContext));
            }
        }
        if (_currencyCode != null)
        {
            if (_currencyCode.isLiteralText())
            {
                converter.setCurrencyCode(_currencyCode.getExpressionString());
            }
            else
            {
                converter.setCurrencyCode( (String) _currencyCode.getValue(elContext));
            }
        }
        if (_currencySymbol != null)
        {
            if (_currencySymbol.isLiteralText())
            {
                converter.setCurrencySymbol(_currencySymbol.getExpressionString());
            }
            else
            {
                converter.setCurrencySymbol( (String) _currencySymbol.getValue(elContext));
            }
        }
        if (_groupingUsed != null)
        {
            if (_groupingUsed.isLiteralText())
            {
                String _groupingUsedValue = _groupingUsed.getExpressionString();
                if (_groupingUsedValue != null)
                    converter.setGroupingUsed(Boolean.valueOf(_groupingUsedValue).booleanValue());
            }
            else
            {
                Object _groupingUsedValue = _groupingUsed.getValue(elContext);
                if (_groupingUsedValue != null)
                    converter.setGroupingUsed( ((Boolean) _groupingUsedValue ).booleanValue());
            }
        }
        if (_integerOnly != null)
        {
            if (_integerOnly.isLiteralText())
            {
                String _integerOnlyValue = _integerOnly.getExpressionString();
                if (_integerOnlyValue != null)
                    converter.setIntegerOnly(Boolean.valueOf(_integerOnlyValue).booleanValue());
            }
            else
            {
                Object _integerOnlyValue = _integerOnly.getValue(elContext);
                if (_integerOnlyValue != null)
                    converter.setIntegerOnly( ((Boolean) _integerOnlyValue ).booleanValue());
            }
        }
        if (_locale != null)
        {
            if (_locale.isLiteralText())
            {
                converter.setLocale(
                    org.apache.myfaces.commons.util.TagUtils.getLocale(_locale.getExpressionString()));
            }
            else
            {
                Object _localeValue = _locale.getValue(elContext);                
                if (_localeValue == null)
                {
                    _localeValue = FacesContext.getCurrentInstance().getViewRoot().getLocale();                
                }
                else
                {
                    _localeValue = org.apache.myfaces.commons.util.TagUtils.getLocale(_localeValue);                
                }
                converter.setLocale((java.util.Locale)_localeValue);
            }
        }
        if (_maxFractionDigits != null)
        {
            if (_maxFractionDigits.isLiteralText())
            {
                String _maxFractionDigitsValue = _maxFractionDigits.getExpressionString();
                if (_maxFractionDigitsValue != null)
                    converter.setMaxFractionDigits(Integer.valueOf(_maxFractionDigitsValue).intValue());
            }
            else
            {
                Object _maxFractionDigitsValue = _maxFractionDigits.getValue(elContext);
                if (_maxFractionDigitsValue != null)
                    converter.setMaxFractionDigits( ((Integer) _maxFractionDigitsValue ).intValue());
            }
        }
        if (_maxIntegerDigits != null)
        {
            if (_maxIntegerDigits.isLiteralText())
            {
                String _maxIntegerDigitsValue = _maxIntegerDigits.getExpressionString();
                if (_maxIntegerDigitsValue != null)
                    converter.setMaxIntegerDigits(Integer.valueOf(_maxIntegerDigitsValue).intValue());
            }
            else
            {
                Object _maxIntegerDigitsValue = _maxIntegerDigits.getValue(elContext);
                if (_maxIntegerDigitsValue != null)
                    converter.setMaxIntegerDigits( ((Integer) _maxIntegerDigitsValue ).intValue());
            }
        }
        if (_minFractionDigits != null)
        {
            if (_minFractionDigits.isLiteralText())
            {
                String _minFractionDigitsValue = _minFractionDigits.getExpressionString();
                if (_minFractionDigitsValue != null)
                    converter.setMinFractionDigits(Integer.valueOf(_minFractionDigitsValue).intValue());
            }
            else
            {
                Object _minFractionDigitsValue = _minFractionDigits.getValue(elContext);
                if (_minFractionDigitsValue != null)
                    converter.setMinFractionDigits( ((Integer) _minFractionDigitsValue ).intValue());
            }
        }
        if (_minIntegerDigits != null)
        {
            if (_minIntegerDigits.isLiteralText())
            {
                String _minIntegerDigitsValue = _minIntegerDigits.getExpressionString();
                if (_minIntegerDigitsValue != null)
                    converter.setMinIntegerDigits(Integer.valueOf(_minIntegerDigitsValue).intValue());
            }
            else
            {
                Object _minIntegerDigitsValue = _minIntegerDigits.getValue(elContext);
                if (_minIntegerDigitsValue != null)
                    converter.setMinIntegerDigits( ((Integer) _minIntegerDigitsValue ).intValue());
            }
        }
        if (_pattern != null)
        {
            if (_pattern.isLiteralText())
            {
                converter.setPattern(_pattern.getExpressionString());
            }
            else
            {
                converter.setPattern( (String) _pattern.getValue(elContext));
            }
        }
        if (_type != null)
        {
            if (_type.isLiteralText())
            {
                converter.setType(_type.getExpressionString());
            }
            else
            {
                converter.setType( (String) _type.getValue(elContext));
            }
        }
        return converter;
    }

    public void release()
    {
        super.release();
        _destType = null;
        _currencyCode = null;
        _currencySymbol = null;
        _groupingUsed = null;
        _integerOnly = null;
        _locale = null;
        _maxFractionDigits = null;
        _maxIntegerDigits = null;
        _minFractionDigits = null;
        _minIntegerDigits = null;
        _pattern = null;
        _type = null;
    }
}
